/* store_and_playback_bidirectional.c */
// try storage scope in C 
// Amend pgm that Oliver fixed 4/19/09, to allow reversed playback

    $NOSYMBOLS        ; keeps listing short

; default Ride7 path, Mar. 16

#include <C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.H> // not used, here, but check that it's OK code 

	#define TABLE_START ((xdata char*)0x800)	// "cast" this as "xdata pointer" to permit loading its value into pointer that's type "xdata"
	#define TABLE_END ((xdata char*)0x802)    // "cast": --necessary to allow comparison with moving pointer value
	#define STARTVAL 1


	xdata char *ADC;
	xdata char *DAC;
	xdata char *STORE_POINTER;	// this is the only moving pointer
	bit INTFLAG;
	sbit UP_DNBAR = P3^4;	// this bit, from a slide switch, controls playback direction
	
// Subroutines (in ass'y lang terms)
// initializations (before enabling interrupts)
	
		void pointer_setup (void)
	     {
	     	ADC = 0x8003;		// ADC start and data port 
			DAC= 0x8002;		// ADC data port 
			STORE_POINTER = TABLE_START;
	     	INTFLAG = 0;
	   	*ADC = STARTVAL;		// start ADC for first pass
   	  }

// interrupt setup, then enabling
   	
	void intsetup (void)
   	{
		EX0 = 1;
		IT0 = 1; //Edge level interrupt
		EA = 1;
		}
	
	
	  	void main (void)
		{		
			pointer_setup();
			intsetup();
			
// Here is the table-fill portion: store one sample each time interrupted
	
				while (STORE_POINTER < TABLE_END)
				{
				  if (INTFLAG)
				  {
						INTFLAG = 0;	// clear the flag for next time

 						(*STORE_POINTER++) = *ADC;	// pick up sample from ADC and store it
 				  }
 				}
 			
// Here is the playback portion: play back one sample each time interrupted--direction determined by slide switch UP_DOWN*	
		 		 			
 			 while(1)//loop forever
 			  {
 			  if (UP_DNBAR)
 			     {

 				    if (STORE_POINTER < TABLE_END)
 				        {
 					       if (INTFLAG)
 				 	         {
 				              INTFLAG =0;
						        *DAC = (*STORE_POINTER++);
	                     }
	    	           }

	    	      
	    	       else
 				        STORE_POINTER = TABLE_START; 	
 				  } 
 				  
 			  else
 			     {
 				    if (STORE_POINTER > TABLE_START)
 				        {
 					       if (INTFLAG)
 				 	         {
 				              INTFLAG =0;
						        *DAC = (*STORE_POINTER--);
	                     }
	    	           }

	    	       else
 				        STORE_POINTER = TABLE_END; 	
 				  }  			  
 	         }
       }


	
	// External interrupt 0 
		void it_ext0 (void) interrupt 0 using 1  // using register bank 1, for 'context switch', though not needed here
	  		{
	  		*ADC = STARTVAL;		// start ADC
	 		INTFLAG = 1;	// set software flag for main program
	 		}
	

	


//	  END
		
